% File run.m
global KJmix
d2r=pi/180; r2d=180/pi;
[Avp, Bvp, Cvp, Dvp]= vehi_pdes;                % Load Pitch Design Model
[Avl, Bvl, Cvl, Dvl]= vehi_ldes;                % Load Lateral Design Model
[A6d, B6d, C6d, D6d]= vehicle_6dof;             % Coupled Body Axes Vehicle
load KSmix.mat -ascii;                          % Load Surfaces Mix Logic
load KJmix.mat -ascii;                          % Load RCS Jets Mix Logic

%alfa0=40; V0=18640; Thet0=39.15;               % Additional Vehicle Parameters
alfa0=42; V0=18640; Thet0=40;                   % Additional Vehicle Parameters
calfa=cos(alfa0*d2r); salfa=sin(alfa0*d2r);

% Two Steps Lateral Control Design ....
Alv= Cvl*Avl*inv(Cvl); Blv= Cvl*Bvl;            % Convert State Vector to ...
[n,n]= size(Cvl); Clv=eye(n); Dlv=Dvl;          % Stability Axes, Outp=States

% Step-1, Using Only Aero-Surfaces
[Ap3,Bp3,Cp3,Dp3]= linmod('Ldes5x');            % 5-state model {p,r,bet,pint,betint}
R=[1,25]*2; R=diag(R);                          % CS LQR Weights R=[1,10]*2
Q=[1 1 1 0.05 0.05]*0.8; Q=diag(Q);             % CS LQR Weights Q=[1 1 1 0.04 0.04]*0.4
kls=lqr(Ap3,Bp3,Q,R); acl=Ap3-Bp3*kls; eig(acl) % Perform LQR design on control surfaces

% Step-2, Using RCS Jets (With Aero-Surfaces Loop Closed)
[Ap4,Bp4,Cp4,Dp4]= linmod('LCS_Closed');        % RCS des model/ Surfaces Loop Closed
R=[1,5]*0.2; R=diag(R);                         % CS LQR Weights R=[1,5]*0.2
Q=[1 1 1 0.2 0.05]*0.4; Q=diag(Q);              % LQR Weights Q=[1 1 1 0.2 0.05]*0.4
klr=lqr(Ap4,Bp4,Q,R); acl=Ap4-Bp4*klr; eig(acl) % Perform LQR design on the RCS

label='Pitch Axis Loop Stability Using Aero-Surfaces Only (RCS opened)'
[As,Bs,Cs,Ds]= linmod('Anal_6dof');             % Frequ Response Model
sys=ss(As,Bs,Cs,Ds);                            % Perform Linearization
w=logspace(-3,3.5,8000);                        % and Frequ domain analysis
figure(1); Nichols(sys,w); title(label)
figure(2); Nyquist(sys,w); title(label)
figure(3); Bode(sys,w);    title(label)